
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.*;

import simulation.Impl.SimulationRMIXMLDocumentObserver;
import simulation.Impl.SimulationWorldState;
import simulation.Impl.SimulationXMLStatisticsObserver;

import massim.SimulationState;
import massim.backup.BackupReader;
import massim.backup.BackupWriter;
import massim.rmi.RMI_Infor;
import massim.rmi.XMLDocumentObserver;
//import massim.server.ServerSimulationContext;
//import massim.server.ServerSimulationContextReceiver;
import massim.server.ServerSimulationContext;
import massim.server.ServerSimulationContextReceiver;
import massim.simulation.simplesimulation.SimulationStateImpl;
import massim.visualization.MainPolicy;
/**
 * This RMIXMLDocumentObserver provides the simulation statistics for the webserver and the servermonitor.
 * 
 * <<< Based on the implementation of Michael Köster and SLawomir Deren (Tournament 2006) >>>
 * 
 * @author Jens Dehnert
 * 
 */
public class GridSimulationRMIXMLDocumentObserverWebInterface extends SimulationRMIXMLDocumentObserver{
	
	String outputFolder;
	private String configFile = "conf" + System.getProperty("file.separator")+"visualconfig.xml";
	
	private DocumentBuilder documentbuilder;
	private Document document;
	
	public GridSimulationRMIXMLDocumentObserverWebInterface() {
		super();
		Document doc = BackupReader.openFile(configFile);
		Element el = (Element) doc.getElementsByTagName("simulationOutput").item(0);
		outputFolder = el.getAttribute("path");
		
		DocumentBuilderFactory factory=DocumentBuilderFactory.newInstance();
		documentbuilder=null;
		try {
			documentbuilder=factory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {throw new RuntimeException(e);}
		document =  documentbuilder.newDocument();
	}
	
	
	public void generateDocument(Document doc, SimulationState simstate) {
	
		SimulationStateImpl simplestate = (SimulationStateImpl) simstate;
		SimulationWorldState worldState = (SimulationWorldState) simplestate.simulationState;
		
		String[] teamName = new String[2];
		int [] teamScore = new int[2];
		teamName[0] = worldState.teamName[0];
		teamName[1] = worldState.teamName[1];
		teamScore[0] = worldState.teamScore[0];
		teamScore[1] = worldState.teamScore[1];
		
		
		String outputFile;
		if(RMI_Infor.FLASH_SERVER_ACTIVATED){
			simulationName  = worldState.simulationName;
			outputFile = outputFolder+simulationName+BackupWriter.file_sep+"masSim-"+simplestate.steps+".swf";
		}
		else{
			outputFile = MainPolicy.svgFile;
		}
		
			//doc = resetDocument();
			Element el_root = doc.getDocumentElement();
			//Element el_root = doc.createElement("statistics");
			el_root.setAttribute(teamName[0], Integer.toString(teamScore[0]));
			el_root.setAttribute(teamName[1], Integer.toString(teamScore[1]));
			el_root.setAttribute("simulation", simulationName);
			el_root.setAttribute("output",outputFile);
		//	doc.appendChild(el_root);
	}
}
