package massim.server;
import static test.ConfigurationUtilities.getNewInstanceFromConfig;

import java.io.File;

import massim.Observer;
import massim.XMLFileWriter;
import massim.XMLOutputObserver;

import org.w3c.dom.Element;

import test.InvalidConfigurationException;

public class FileXMLDocumentObserverFactory implements ObserverFactory {

	public Observer createObserver(Element config, String simulationid) throws InvalidConfigurationException {
		String className = config.getAttribute("xmlobserver");
		String prefix = config.getAttribute("xmlobserverpath");
		XMLOutputObserver r = getNewInstanceFromConfig(className);
		XMLFileWriter obs = new XMLFileWriter();
		obs.setFile(new File(prefix+simulationid+".xml"));
		r.addObserver(obs);
		return r;
	}
}
